#include <iostream>
using namespace std;

#define STATIC_LIB 1
#define IMPLICIT_DYNAMIC_LIB 2
#define EXPLICIT_DYNAMIC_LIB 3

#define LIB_TYPE 3
#if (LIB_TYPE == 1)

#include "StaticFunctions.h"
//#include "..\StaticLib\StaticFunctions.h"
#pragma comment(lib, "StaticLib.lib")

int main() {
	srand(time(NULL));
	int n, * a;
	cout << "running programm using static lib\n";
	cout << "enter n integer number: ";
	cin >> n;
	cout << "\nyouur araay: " << endl;
	a = new int[n];
	for (int i = 0; i < n; i++) {
		a[i] = rand() % 100 - 50;
		printf("%4d", a[i]);
	}
	func::BubbleSort(a, n);
	cout << "\nyour sorted array: " << endl;
	for (int i = 0; i < n; i++)
		printf("%4d", a[i]);
	delete[] a;
}

#elif (LIB_TYPE == 2) //  
//#pragma comment(lib, "DynamicLib.dll")
#include "DynamicFunctions.h"
int main() {
	srand(time(NULL));
	int n, * a;
	cout << "running programm using implict dynamic lib\n";
	cout << "enter n integer number: ";
	cin >> n;
	cout << "\nyouur araay: " << endl;
	a = new int[n];
	for (int i = 0; i < n; i++) {
		a[i] = rand() % 100 - 50;
		printf("%4d", a[i]);
	}
	func::BubbleSort(a, n);
	cout << "\nyour sorted array: " << endl;
	for (int i = 0; i < n; i++)
		printf("%4d", a[i]);
	delete[] a;
}
#elif (LIB_TYPE == 3) // 
#include <Windows.h>

int main() {
	srand(time(NULL));
	int n, * a;
	cout << "running programm using explict dynamic lib\n";
	cout << "enter n integer number: ";
	cin >> n;
	cout << "\nyouur araay: " << endl;
	a = new int[n];
	for (int i = 0; i < n; i++) {
		a[i] = rand() % 100 - 50;
		printf("%4d", a[i]);
	}
	typedef int(*FuncType) (int[], int);
	FuncType BubbleSort;
	HINSTANCE hdll = LoadLibrary(L"DynamicLib.dll");
	if (nullptr == hdll)
		cout << "   Dll." << std::endl;
	else {
		FARPROC ptr = GetProcAddress(hdll, "BubbleSort");

		if (nullptr == ptr)
			cout << "    ." << endl;
		else {
			BubbleSort = (FuncType)ptr;
			BubbleSort(a, n);
		}
		cout << "\nyour sorted array: " << endl;
		for (int i = 0; i < n; i++)
			printf("%4d", a[i]);
		delete[] a;
		FreeLibrary(hdll);
	}
}
#endif